<?php
/*
Module Name : Spam Stats
Module URI : http://082net.com/tag/wp-slimstat-ex/
Author : Cheon, Young-Min
Author URI : http://082net.com/
License : All Wp-SlimStat-Ex Pins are GPL
Powered by SlimStat(http://wettone.com/code/slimstat)'s PathStats plugin
*/

if (!defined('SLIMSTATPATH')) { header('Location:/'); }

class BBSpamStats extends SSPins {
	// About this Pin
	var $Pinfo = array(
		'title' => 'Bad Behavior',
		'author' => '082net',
		'url' => 'http://082net.com',
		'text' => 'Show Bad Behavior Stats(http://www.homelandstupidity.us/software/bad-behavior/).',
		'version' => '0.8',
		'type' => 0,
	);

	// About displayable modules of this Pin
	var $Moinfo = array(// function name, module title
		0 => array( 'name' => '_moduleBBSpamStats', 'title' => 'Recent Visitors Bad Behaviour' ),
	);

	var $rows = 50;//limit rows.
	var $show_unblocked = false; //show unblocked behavior(key:00000000) or not? show = true, hide = false
	var $check_table;
	var $table_error = '<br /><div class="updated fade"><p style="text-align:center;font-size:1.2em;padding:4px 2px;">Cannot find &quot;Bad Behavior&quot; table</p></div>';
	var $plugin_error = '<br /><div class="updated fade"><p style="text-align:center;font-size:1.2em;padding:4px 2px;">Make sure you activated &quot;Bad Behavior&quot; plugin</p></div>';

	function BBSpamStats() {
		$this->_isBBDetected();
	}

	function pin_compatible() {
		global $SlimCfg;
		if($SlimCfg->version < '2.1') {
			return array	('compatible' => false, 'message' => 'BBSpamStats is only compatible with SlimStat-Ex 2.1 and above.');
		} else {
			return array('compatible' => true);
		}
	}

	function _replaceFilterClause($filter) {
		$replaced = str_replace('%%COLUMN%%', 'ts.ip', $filter);
		return $replaced;
	}

	function _moduleBBSpamStats($args='') {
		global $wpdb, $table_prefix, $SlimCfg;
		$filter_clause = SSFunction::get_filter_clause();
		$args = wp_parse_args($args, array('links'=>false, 'navi'=>true));

		$use_ajax = $SlimCfg->option['use_ajax'];
		if(!defined('BB2_CORE'))
			return $this->plugin_error;
		if(!$this->check_table)
			return $this->table_error;
		$filter_clause = $this->_replaceFilterClause($filter_clause);
		$offset = $SlimCfg->get_db_offset($this->rows);
		$pinid =& $this->getPinID();
		$moid =& $this->getMoID(0);

		$str = "";
		// get requests
		$query = "SELECT ts.id, ts.ip, UNIX_TIMESTAMP(ts.date) AS dt, ts.request_uri AS uri, ";
		$query .= " ts.server_protocol AS ptc, ts.request_method AS method, ts.user_agent AS ua, ts.key ";
		$query .= " FROM {$table_prefix}bad_behavior ts";
		$query .= " WHERE {$filter_clause} ";
		$query .= $this->show_unblocked ? "" : " AND ts.key <> '00000000' ";
		$query .= " ORDER BY dt DESC, ts.ip";
		$query .= " LIMIT {$offset},{$this->rows}";
		$result = mysql_query( $query );
		if ( $result && 0 < mysql_num_rows($result) ) {
			$prev_visit = 0;
			$visits = array();
			$visit = array();
			$pages = array();
			while ( $assoc = mysql_fetch_assoc( $result ) ) {
				if ( $assoc["ip"] != $prev_visit && !empty( $visit ) ) {
					$visits[] = $visit;
					$visit = array();
				}
				$visit[] = $assoc;
				$prev_visit = $assoc['ip'];
			}
			if ( !empty( $visit ) ) {
				$visits[] = $visit;
			}
			$str .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
			$str .= "<thead><tr><th class=\"first\">".__('Visitor', SLIMSTAT_DOMAIN).($use_ajax?" &ndash; <a href=\"#\" onclick=\"SlimStat.toggleAllSubs(this);return false;\">expand</a> (all)":"")."</th>";
			$str .= "<th class=\"second\">".__('When', SLIMSTAT_DOMAIN)."</th>";
			$str .= "<th class=\"third\">".__('Method (protocol)', SLIMSTAT_DOMAIN)."</th>";
			$str .= "<th class=\"third\">".__('Support Key', SLIMSTAT_DOMAIN)."</th>";
			$str .= "<th class=\"third last\">".__('Country', SLIMSTAT_DOMAIN)."</th></tr></thead><tbody>\n";
			
			$svr_today = $SlimCfg->midnight_db;
			$i = 0;
			foreach ( $visits as $visit ) {
				$subcontgl_class = ($i==0 || !$use_ajax) ? '' : ' class="collapsed"';
				$is_today = ( $visit[0]["dt"] >= $svr_today );
				$mindt = $this->time_label( $visit[0]["dt"] );
				$maxdt = $this->time_label( $visit[ sizeof( $visit )-1 ]["dt"] );
				$filter1 = array('fi'=> urlencode($visit[0]["ip"]).'&amp;ff=3&amp;ft=0');
				$filter2 = array('fi'=> urlencode($visit[0]["ip"]).'&amp;ff=99&amp;ft=0');

				$str .= "<tr".($use_ajax ? " onclick=\"SlimStat.toggleSub(this);\" style=\"cursor:pointer;\"{$subcontgl_class}" : "").">";
				$str .= "<td class=\"accent first\">".SSFunction::_whoisLink($visit[0]["ip"])." (".count($visit).") ".SSFunction::filterBtn($filter1, 3).SSFunction::filterBtn($filter2, $pinid)." ".($use_ajax ? "<span class=\"subcontgl\">".SSFunction::blank_image('toggle', 'icons')."</span>":"")."</td>";
				$str .= "<td class=\"accent second\">";
				if ( $is_today ) {
					$str .= ( ( $mindt == $maxdt ) ? $mindt : $mindt."-".$maxdt );
				} else {
					$str .= $this->time_label( $visit[0]["dt"], time() );
				}
				$str .= "</td>";
				$str .= "<td class=\"accent third\">".substr($visit[0]["method"],-4).(($visit[0]["ptc"] != '')?' ('.$visit[0]["ptc"].')':'')."</td>";
				$str .= "<td class=\"accent third\">".$this->print_support_key($visit[0]["ip"], $visit[0]["key"])."</td>";
				$country = "c-".strtolower(SSTrack::_determineCountry($visit[0]["ip"]));
				$str .= "<td class=\"accent third last\">".SSFunction::get_flag( $country )." ".__($country, SLIMSTAT_DOMAIN)."</td></tr>\n";
				
				$prev_dt = "";
				$prev_ua = "";
				$str .= '<tr class="'.($i==0 || !$use_ajax ? 'subcons' : 'collapsed-subcons').'"><td colspan="5"><table border="0" cellspacing="0" cellpadding="0"><tbody>';
				foreach ( $visit as $hit ) {
					if(!$use_ajax) $subcon_class = '';
					$resource2title = SSFunction::_guessPostTitle($hit["uri"]);
					$svr_todayhit = $SlimCfg->mktime( array('h'=>0, 'i'=>0, 's'=>0), $visit[0]["dt"], 'db');
					$is_todayhit = ( $hit["dt"] >= $svr_todayhit );
					$str .= "<tr><td class=\"first\">";
					$str .= "<a href=\"".$hit["uri"]."\" class=\"external\"";
					$str .= " title=\"Resource: ".strip_tags($resource2title)."\">";
					$str .= "<img src=\"".$SlimCfg->pluginURL."/css/external.gif\" width=\"9\" height=\"9\" alt=\"go\" /></a>&nbsp;&nbsp;";
					$filter = "&amp;fi=".urlencode($hit["uri"])."&amp;ff=2&amp;ft=0";
					$str .= $resource2title;
					$str .= "</td>";
					$dt_label = (($is_todayhit)?'':$SlimCfg->date("j M, ", $SlimCfg->time_switch($hit["dt"], 'blog'))).$this->time_label( $hit["dt"] );
					if ( ( !$is_today && $prev_dt == "" ) || ( $mindt != $maxdt && $dt_label != $prev_dt ) ) {
						$str .= "<td class=\"second\">".$dt_label."</td>";
					} else {
						$str .= "<td class=\"second\">&nbsp;</td>";
					}
					$str .= "<td colspan=\"3\" class=\"last third\" style=\"text-align:center;\">";
					$str .= (( $hit["ua"] != $prev_ua )?$SlimCfg->truncate($hit["ua"], 64):"&nbsp;")."</td>";
					$prev_dt = $dt_label;
					$prev_ua = $hit["ua"];
					$str .= "</tr>\n";					
				}
				$str .= '</tbody></table></td></tr>';
				$i++;
			}
			$str .= "</tbody></table>\n";
		} else {
			$str = '';
		}
		return SSFunction::get_module_custom($moid, $str, $args);
	}

	function get_log($key="") {
		require_once(BB2_CORE . '/responses.inc.php');
		$key = trim($key);
		$response = bb2_get_response($key);
		if($response[0] == '00000000') return " title=\"unkwon behavior\""; 
		$output = " title=\"";
		$output .= $response['response']. ' :: '.((!empty($response['log']))?$response['log']:'No informations'). '"';
		return $output;
	}

	function print_support_key($ip, $key) {
		$ip = explode(".", $ip);
		$ip_hex = "";
		foreach ($ip as $octet) {
			$ip_hex .= str_pad(dechex($octet), 2, 0, STR_PAD_LEFT);
		}
		$support_key = implode("-", str_split($ip_hex.$key, 4));
		$link = "<a href=\"http://www.ioerror.us/bb2-support-key?key=".$support_key."\" onclick=\"window.open(this.href, 'SupportKey', 'width=800,height=500'); return false;\"".$this->get_log($key).">".$support_key."</a>";
		
		return $link;
	}

	function _isBBDetected() {
		global $wpdb, $table_prefix;
		
		$_table_exists = false;
		$_table = $table_prefix."bad_behavior";
		foreach ( $wpdb->get_col("SHOW TABLES", 0) as $table ) {
			if ( $table == $_table ) {
				$_table_exists = true;
				break;
			}
		}
		$this->check_table = $_table_exists;
	}

	function time_label( $_dt, $_compared_to_dt=0 ) {
		global $SlimCfg;
		$usr_dt = $SlimCfg->time_switch($_dt, 'blog');
		if ( $_compared_to_dt == 0 ) {
			if ( $SlimCfg->date( "a", $usr_dt ) == "" ) {
				return $SlimCfg->date( "H:i", $usr_dt );
			} else {
				return strtolower( $SlimCfg->date( "g:i a", $usr_dt ) );
			}
			//return strftime( "%r", $usr_dt );
		} elseif ( $_dt >=  $SlimCfg->mktime( array('h'=>0, 'i'=>0, 's'=>0), $_compared_to_dt ) ) {
			return $this->time_label( $_dt );
		} else {
			return $SlimCfg->date( "j M", $usr_dt );
		}
	}

	function _displayPanel() {
		if(!defined('BB2_CORE')) {
			echo $this->plugin_error;
		} elseif ($this->check_table) { // if bad behavior table exists
			global $table_prefix, $SlimCfg;
			echo $this->_filterIntervalLink();
			echo $this->current_filters();
			echo $this->_moduleBBSpamStats( array('class'=>'full') );
		} else {
			echo $this->table_error;
		}
	}

}//end of class

?>