<?php
/*
Module Name : Download Manager
Module URI : http://082net.com/tag/wp-slimstat-ex/
Author : Cheon, Young-Min
Author URI : http://082net.com/
License : All Wp-SlimStat-Ex Pins are GPL
This is example of Wp-SlimStat-Ex Pin
*/
/*
$Pinfo : Informations of this pin which will saved in database(usually 'wp_slim_pins')
	name => Pin's name. This must exactly same as Pin's class name (class SSDL_Mgr extends SSPins { .... )
	title => This will be showed at Wp-SlimStat's menu link ( Summary | Feeds | Details | .... | Downloads | .... )
	author => Author's name(can be your name)
	url => Author's or downloadable Pin's URL
	text => Pin's description
	version => current Pin's version

$Moinfo : Modules displayed on this Pin's panel. You must add your displayable modules in this array
			(module's number must start from "0" and each modules have child array values(name, title) )
		name : module's function name ( e.g. function _moduleTop() { .... } would be '_moduleTop')
		title : module's display name(title) which will be showed at module's header

Basic functions : 

	function Your_Class_Name() : Same name as class name ( e.g. class SSDL_Mgr extends.... function SSDL_Mgr() { ... } )
	function &getPinID() : get pin's ID from database. ( Pin's id(on database) + 100 )
	function &getMoID($num) : get module's ID from database. $num is array number you setted on $Moinfo ( e.g. 0=>array('name'=>........) )
	function _displayPanel() : Usually contains some base functions(below). Actually, this is the main function to be showed on Wp-SlimStat page.
				(You must "echo" your contents not "return" )
					$myFilters = $this->get['fd_encode'].$this->get['fi_encode']; // Retrieve filters from url
					$_html .= $this->_getFilterForm();// insert filter form. 
						( You must wrap your contnets with <div id="filterd_result"> your contents </div> )
					$_filter = $this->filter_switch();// If a filter by keyword was set, add it to the SQL WHERE clause

You can call SlimStat's options and config by global $SlimCfg;  $SlimCfg->table_stats; $SlimCfg->option['visit_type'] ....etc.
You surely can use any functions in 'wp-slimstat-ex/lib/functions.php' file( SSFunction class ) by SSFunction::_function_name()
It would be more better if you check modules.php.
See below example.
*/

/* Please fill in $Pinfo values */

if (!defined('SLIMSTATPATH')) { header('Location:/'); }

class SSDL_MgrN extends SSPins {
	// About this Pin
	var $Pinfo = array(
		'title' => 'Downloads',
		'author' => '082net',
		'url' => 'http://082net.com',
		'text' => 'Download manager database version. Show download stats for download-manager(http://guff.szub.net/plugins/)',
		'version' => '0.8',
		'type' => 0,
	);

	// About displayable modules of this Pin
	var $Moinfo = array(// function name, module title
		0 => array( 'name' => '_moduleTop', 'title' => 'Top downloads' ),
		1 => array( 'name' => '_moduleRecent', 'title' => 'Recent downloads' ),
	);

	var $check_table;
	var $table_error = '<br /><div class="updated fade"><p style="text-align:center;font-size:1.2em;padding:4px 2px;">Cannot find &quot;Downloads&quot; table</p></div>';

	function SSDL_MgrN() {
		$this->_isDMGRDetected();
	}

	function pin_compatible() {
		global $SlimCfg;
		if($SlimCfg->version < '2.1') {
			return array	('compatible' => false, 'message' => 'Download Manager is only compatible with SlimStat-Ex 2.1 and above.');
		} else {
			return array('compatible' => true);
		}
	}

	function _isDMGRDetected() {
		global $wpdb, $table_prefix;
		
		$_table_exists = false;
		$_table = $table_prefix."downloads";
		foreach ( $wpdb->get_col("SHOW TABLES", 0) as $table ) {
			if ( $table == $_table ) {
				$_table_exists = true;
				break;
			}
		}
		$this->check_table = $_table_exists;
	}

	function _replaceFilterClause($filter) {
		global $SlimCfg;
		$replaced = str_replace('%%COLUMN%%', 'ts.file_name', $filter);
		$replaced = preg_replace('#\s+ts\.dt\s+#', ' UNIX_TIMESTAMP(ts.date) ', $replaced);
		return $replaced;
	}

	function _moduleTop($args='') {
		global $wp_version, $table_prefix, $SlimCfg;
		if(!$this->check_table) 
			return $this->table_error;
		$filter_clause = SSFunction::filter_switch();
		$filter_clause = $this->_replaceFilterClause($filter_clause);
		$args = wp_parse_args($args, array('links'=>false, 'navi'=>true));

		$sql[0] = "SELECT ts.file_name, COUNT(*) AS countall, MAX(UNIX_TIMESTAMP(ts.date)) AS dt
			FROM {$table_prefix}downloads ts
			WHERE $filter_clause 
			GROUP BY ts.file_name 
			ORDER BY countall DESC
			LIMIT {$SlimCfg->db_offset}, ".$SlimCfg->option['limitrows'];


		$cols[0]['title'] = __('File name', SLIMSTAT_DOMAIN);
		$cols[0]['class'] = 'first';
		$filter_btn = SSFunction::filterBtn(array('fi'=>'%2$s&amp;ff=99&amp;ft=0'), $this->getPinID());
		$cols[0]['html'] = '%1$s '.$filter_btn;
		$cols[0]['formats'][0] = array('file_name.short', 'file_name.encode');

		$cols[2]['title'] = __('Hits', SLIMSTAT_DOMAIN);
		$cols[2]['class'] = 'second';
		$cols[2]['html'] = '%s';
		$cols[2]['formats'][0] = array('countall.integer');

		$cols[2]['title'] = __('last', SLIMSTAT_DOMAIN);
		$cols[2]['class'] = 'last';
		$cols[2]['html'] = '%s';
		$cols[2]['formats'][0] = array('dt.date');

		$moid =& $this->getMoID(0);
		return SSFunction::getModule($moid, $sql, $cols, $args);
	}

	function _moduleRecent($args='') {
		global $table_prefix, $SlimCfg;
		if(!$this->check_table)
			return $this->table_error;
		$filter_clause = SSFunction::filter_switch();
		$filter_clause = $this->_replaceFilterClause($filter_clause);
		$args = wp_parse_args($args, array('links'=>false, 'navi'=>true, 'class'=>'wide'));

		$sql[0] = "SELECT ts.file_name, ts.referer, ts.remote_addr, UNIX_TIMESTAMP(ts.date) AS dt  
			FROM {$table_prefix}downloads ts
			WHERE $filter_clause 
			ORDER BY dt DESC
			LIMIT {$SlimCfg->db_offset}, ".$SlimCfg->option['limitrows'];

		$cols[0]['title'] = __('File name', SLIMSTAT_DOMAIN);
		$cols[0]['class'] = 'first';
		$filter_btn1 = SSFunction::filterBtn(array('fi'=>'%4$s&amp;ff=99&amp;ft=0'), $this->getPinID());
		$cols[0]['html'] = '<span class="external"><a%1$s title="'.__('Downloaded from', SLIMSTAT_DOMAIN).': %2$s"><img src="'.$SlimCfg->pluginURL.'/css/external.gif" alt="" /></a></span>&nbsp;&nbsp;%3$s '.$filter_btn1;
		$filter_btn2 = SSFunction::filterBtn(array('fi'=>'%7$s&amp;ff=3&amp;ft=0'), 3);
		$cols[0]['html'] .= ' <span> &#64;&nbsp; %5$s %6$s ' . $filter_btn2 . '</span>';
		$cols[0]['formats'][0] = array('referer.encode_prefix', 'referer.short', 'file_name.medium', 'file_name.encode', 'remote_addr.flag', 'remote_addr.remote_ip', 'remote_addr.encode');

		$cols[1]['title'] = __('When', SLIMSTAT_DOMAIN);
		$cols[1]['class'] = 'last';
		$cols[1]['html'] = '%s';
		$cols[1]['formats'][0] = array('dt.date');

		$moid =& $this->getMoID(1);
		
		return SSFunction::getModule($moid, $sql, $cols, $args);
	}

	function _displayPanel() {
		if($this->check_table) {
		// Initialize content for this panel
//		$_html .= SSFunction::_getFilterForm();
		// If a filter by keyword was set, add it to the SQL WHERE clause
		$_html = $this->_filterIntervalLink();
		$_html .= $this->current_filters();
		$_html .= $this->_moduleRecent();
		$_html .= $this->_moduleTop();
		echo $_html;
		} else {
			echo $this->table_error;
		}
	}

}//end of class
?>